// Control_amort.cpp: Implementación de los dispositivos de la zona controladora del amortiguador. 


#include "base.h"
#include "sistemas/controlador_amortiguador.h"
#include "sistemas/constante.h"
#include "sistemas/funciones_periodicas.h"

#include <iostream>

int main()
{

	
// CREACION DE WATCHDOGS ---------------------------------------------------------------------

	Watchdog<float> *watchdog_control_amort = new Watchdog<float>(10,5201);

// CREACION DE CONTROLADORES -----------------------------------------------------------------
	
	Control_amortiguador *control_amort = new Control_amortiguador(50,1201, watchdog_control_amort,19190,20320,0);
	
// CREACION DE DISPOSITIVOS GENERADORES Y FUNCIONES MATEMATICAS ------------------------------

//	Periodica *consigna = new Periodica(100,201,cuadrada,100,100,-0.1,0.1);
	Constante *consigna = new Constante(1,2201,0,-1000,1000);

// CREACION DE BUSES -------------------------------------------------------------------------
	
	Bus *bus = new Bus(3201, PROCESO_CONTROLADOR);	

// CREACION DE DISCRETIZADORES ---------------------------------------------------------------
	
	Discretizador *discret_amo = new Discretizador(50,4201,2, bus);	
	
	
// CREACION DE CONECTORES --------------------------------------------------------------------
	
	Conector *control_dis = new Conector(6201); // Entre controlador y discretizador 
	Conector *consig_control = new Conector(6202); // Entre consigna y controlador	
	
										   
// CREACION DE GRABADORES --------------------------------------------------------------------

										   
// CREACION DE LOS CONECTORES DE RECOLECCION DE DATOS (para grabar)---------------------------

	
// CONECTAMOS TODOS LOS COMPONENTES	----------------------------------------------------------	
		
	control_amort -> conectar(control_dis,1); 
	discret_amo -> asociar(control_dis); // Obtiene datos en discretizador, para E/S, con este conector 
	discret_amo -> conectar(control_dis, 1); // Conectado
	
	
	consigna -> conectar(consig_control, 1); // Conectamos controlador a la consigna
	control_amort -> conectar(consig_control, 2);
	
// CREAMOS SONDAS PARA GRABAR DATOS A ARCHIVO EXTERNO ----------------------------------------		


// REGISTRAMOS CONTROLADORES EN WATCHDOGS ----------------------------------------------------
	
	watchdog_control_amort -> registrar(control_amort, 20, true);

// CREAMOS EL MENU INTERACTIVO ---------------------------------------------------------------
	
	Interactivo menu;
	
// REGISTRAMOS TODOS LOS DISPOSITIVOS EN EL MENU INTERACTIVO
	
	
	menu.registro(control_dis, "conector control-discret");
	menu.registro(consig_control, "conector consigna-control");
	menu.registro(discret_amo, "Discretizador controlador");
	menu.registro(control_amort, "Controlador amortiguador");
	menu.registro(watchdog_control_amort,"Watchdog-amortiguador");
	menu.registro(consigna,"Consigna de entrada");
	menu.registro(bus, "Bus");
//	menu.registro(grabador, "Grabador");
	
// EJECUTAMOS MENU INTERACTIVO ---------------------------------------------------------------

	menu.ejecutar(true); // ejecutamos y liberamos todos los objetos llamando a sus destructores (true)	
	
	std::cout << "\nSalida del programa CONTROL\n";  // Mensaje final
		
	return 0;
	
}