// Control_CARRO.cpp: Implementación de los dispositivos controladores del CARRO

#include "base.h"
#include "sistemas/controlador_carro_motorizado.h"
#include "sistemas/constante.h"
//#include "sistemas/funciones_periodicas.h"

#include <iostream>

int main()
{

	
// CREACION DE WATCHDOGS ---------------------------------------------------------------------

	Watchdog<float> *watchdog_control_carro = new Watchdog<float>(20,5501);

// CREACION DE CONTROLADORES -----------------------------------------------------------------
	
	Control_carro *control_carro = new Control_carro(50,1501, watchdog_control_carro, false); 
																// primer desplazamiento del carro, a la derecha
	
// CREACION DE DISPOSITIVOS GENERADORES Y FUNCIONES MATEMATICAS ------------------------------

	Constante *consigna_vol = new Constante(1,2501,60,-1000,1000); // Voltaje inicial a 60 voltios (absolutos)
	Constante *consigna_con = new Constante(1,2502,500,0,1000000); // 10 segundos carro sin voltaje -> 10*50 = 500 

// CREACION DE BUSES -------------------------------------------------------------------------
	
	Bus *bus = new Bus(3501, PROCESO_CONTROLADOR);	

// CREACION DE DISCRETIZADORES ---------------------------------------------------------------
	
	Discretizador *discret_car = new Discretizador(50,4501,2, bus);	
	
	
// CREACION DE CONECTORES --------------------------------------------------------------------
	
	Conector *vol_control = new Conector(6501); // Entre controlador y consigna voltaje 
	Conector *con_control = new Conector(6502); // Entre controlador y consigna contador
	Conector *control_dis = new Conector(6503); // Entre controlador y discretizador
	
										   
// CREACION DE GRABADORES --------------------------------------------------------------------	

										   
// CREACION DE LOS CONECTORES DE RECOLECCION DE DATOS (para grabar)---------------------------

	
// CONECTAMOS TODOS LOS COMPONENTES	----------------------------------------------------------	
		
	control_carro -> conectar(control_dis,1); 
	discret_car -> asociar(control_dis); // Obtiene datos en discretizador, para E/S, con este conector 
	discret_car -> conectar(control_dis, 1); // Conectado	
	
	consigna_vol -> conectar(vol_control, 1); // Conectamos controlador a la consigna
	control_carro -> conectar(vol_control, 2);
	
	consigna_con -> conectar(con_control, 1); // Conectamos controlador a la consigna
	control_carro -> conectar(con_control, 3);
	
// CREAMOS SONDAS PARA GRABAR DATOS A ARCHIVO EXTERNO ----------------------------------------		


// REGISTRAMOS CONTROLADORES EN WATCHDOGS ----------------------------------------------------
	
	watchdog_control_carro -> registrar(control_carro, 20, true); // Registro del controlador en el watchdog
											// Conteo de 20 (ver fmuestreo de watchdog, y cierre si se supera)

// CREAMOS EL MENU INTERACTIVO ---------------------------------------------------------------
	
	Interactivo menu;
	
// REGISTRAMOS TODOS LOS DISPOSITIVOS EN EL MENU INTERACTIVO ---------------------------------	
	
	menu.registro(control_dis, "conector control-carro");
	menu.registro(vol_control, "conector voltaje-control");
	menu.registro(con_control, "conector conteo-control");
	menu.registro(discret_car, "Discretizador controlador");
	menu.registro(control_carro, "Controlador carro");
	menu.registro(watchdog_control_carro,"Watchdog-carro");
	menu.registro(consigna_vol,"Consigna de voltaje");
	menu.registro(consigna_con,"Consigna de conteo");
	menu.registro(bus, "Bus");
	
// EJECUTAMOS MENU INTERACTIVO ---------------------------------------------------------------

	menu.ejecutar(true); // ejecutamos y liberamos todos los objetos llamando a sus destructores (true)	
	
	std::cout << "\nSalida del programa CONTROL\n";  // Mensaje final
		
	return 0;
	
}