// CONTROL_DEPOSITO.CPP  Controlador del depósito de agua

#include "base.h"
#include "sistemas/controlador_deposito.h"
#include "sistemas/constante.h"

#include <iostream>

int main()
{
	
// CREACION DE WATCHDOGS ---------------------------------------------------------------------

	Watchdog<float> *watchdog_control_deposito = new Watchdog<float>(20,5701);

// CREACION DE CONTROLADORES -----------------------------------------------------------------
	
	Control_deposito *control_deposito = new Control_deposito(50,1701, watchdog_control_deposito,0.05,1,1,0);
	
	// Nota: Se limita el caudal de salida. Limitación física. 
	
// CREACION DE DISPOSITIVOS GENERADORES Y FUNCIONES MATEMATICAS ------------------------------

	Constante *consigna = new Constante(1,2701,1,0,10);

// CREACION DE BUSES -------------------------------------------------------------------------
	
	Bus *bus = new Bus(3701, PROCESO_CONTROLADOR);	

// CREACION DE DISCRETIZADORES ---------------------------------------------------------------
	
	Discretizador *discret_dep = new Discretizador(50,4701,2, bus);	
	
	
// CREACION DE CONECTORES --------------------------------------------------------------------
	
	Conector *control_dis = new Conector(6701); // Entre controlador y discretizador 
	Conector *consig_control = new Conector(6702); // Entre consigna y controlador	
	
										   
// CREACION DE GRABADORES --------------------------------------------------------------------	

										   
// CREACION DE LOS CONECTORES DE RECOLECCION DE DATOS (para grabar)---------------------------

	
// CONECTAMOS TODOS LOS COMPONENTES	----------------------------------------------------------	
		
	control_deposito -> conectar(control_dis,1); 
	discret_dep -> asociar(control_dis); // Obtiene datos en discretizador, para E/S, con este conector 
	discret_dep -> conectar(control_dis, 1); // Conectado	
	
	consigna -> conectar(consig_control, 1); // Conectamos controlador a la consigna
	control_deposito -> conectar(consig_control, 2);
	
// CREAMOS SONDAS PARA GRABAR DATOS A ARCHIVO EXTERNO ----------------------------------------		


// REGISTRAMOS CONTROLADORES EN WATCHDOGS ----------------------------------------------------
	
	watchdog_control_deposito -> registrar(control_deposito, 20, true); // Registro del controlador en el watchdog
											// Conteo de 20 (ver fmuestreo de watchdog, y cierre si se supera)

// CREAMOS EL MENU INTERACTIVO ---------------------------------------------------------------
	
	Interactivo menu;
	
// REGISTRAMOS TODOS LOS DISPOSITIVOS EN EL MENU INTERACTIVO ---------------------------------	
	
	menu.registro(control_dis, "conector control-discret");
	menu.registro(consig_control, "conector consigna-control");
	menu.registro(discret_dep, "Discretizador controlador");
	menu.registro(control_deposito, "Controlador deposito");
	menu.registro(watchdog_control_deposito,"Watchdog-deposito");
	menu.registro(consigna,"Consigna de entrada");
	menu.registro(bus, "Bus");
	
// EJECUTAMOS MENU INTERACTIVO ---------------------------------------------------------------

	menu.ejecutar(true); // ejecutamos y liberamos todos los objetos llamando a sus destructores (true)	
	
	std::cout << "\nSalida del programa CONTROL\n";  // Mensaje final
		
	return 0;
	
}