//
// Control_motorcc.cpp: Implementación de los dispositivos controladores para el motor de corriente continua
//


#include "base.h"
#include "sistemas/controlador_motorcc.h"
#include "sistemas/constante.h"
//#include "sistemas/funciones_periodicas.h"

#include <iostream>

int main()
{

	
// CREACION DE WATCHDOGS ---------------------------------------------------------------------

	Watchdog<float> *watchdog_control_motorCC = new Watchdog<float>(20,5101);

// CREACION DE CONTROLADORES -----------------------------------------------------------------
	
	Control_motorCC *control_motorCC = new Control_motorCC(50,1101, watchdog_control_motorCC,1,1.5,0, false);
	
// CREACION DE DISPOSITIVOS GENERADORES Y FUNCIONES MATEMATICAS ------------------------------

	Constante *consigna = new Constante(1,2101,100,-1000,1000);

// CREACION DE BUSES -------------------------------------------------------------------------
	
	Bus *bus = new Bus(3101, PROCESO_CONTROLADOR);	

// CREACION DE DISCRETIZADORES ---------------------------------------------------------------
	
	Discretizador *discret_mot = new Discretizador(50,4101,2, bus);	
	
	
// CREACION DE CONECTORES --------------------------------------------------------------------
	
	Conector *control_dis = new Conector(6101); // Entre controlador y discretizador 
	Conector *consig_control = new Conector(6102); // Entre consigna y controlador	
	
										   
// CREACION DE GRABADORES --------------------------------------------------------------------	

										   
// CREACION DE LOS CONECTORES DE RECOLECCION DE DATOS (para grabar)---------------------------

	
// CONECTAMOS TODOS LOS COMPONENTES	----------------------------------------------------------	
		
	control_motorCC -> conectar(control_dis,1); 
	discret_mot -> asociar(control_dis); // Obtiene datos en discretizador, para E/S, con este conector 
	discret_mot -> conectar(control_dis, 1); // Conectado
	
	
	consigna -> conectar(consig_control, 1); // Conectamos controlador a la consigna
	control_motorCC -> conectar(consig_control, 2);
	
// CREAMOS SONDAS PARA GRABAR DATOS A ARCHIVO EXTERNO ----------------------------------------		


// REGISTRAMOS CONTROLADORES EN WATCHDOGS ----------------------------------------------------
	
	watchdog_control_motorCC -> registrar(control_motorCC, 20, true); // Registro del controlador en el watchdog
											// Conteo de 20 (ver fmuestreo de watchdog, y cierre si se supera)

// CREAMOS EL MENU INTERACTIVO ---------------------------------------------------------------
	
	Interactivo menu;
	
// REGISTRAMOS TODOS LOS DISPOSITIVOS EN EL MENU INTERACTIVO ---------------------------------	
	
	menu.registro(control_dis, "conector control-motor");
	menu.registro(consig_control, "conector consigna-control");
	menu.registro(discret_mot, "Discretizador controlador");
	menu.registro(control_motorCC, "Controlador motorcc");
	menu.registro(watchdog_control_motorCC,"Watchdog-motorcc");
	menu.registro(consigna,"Consigna de entrada");
	menu.registro(bus, "Bus");
	
// EJECUTAMOS MENU INTERACTIVO ---------------------------------------------------------------

	menu.ejecutar(true); // ejecutamos y liberamos todos los objetos llamando a sus destructores (true)	
	
	std::cout << "\nSalida del programa CONTROL\n";  // Mensaje final
		
	return 0;
	
}