// CONTROL_MOTORCC_ARDUINO.CPP -------- Control arduino del motor de corriente continua
// El controlador integrado es PID y se utilizará el esquema reducido para grabar en la memoria del microcontrolador
// Debido a la limitación de memoria y prestaciones de la CPU no se puede utilizar multihilos ni objetos STL
// como vectores y colas dinámicas. En su defecto, se utilizará memoria estática. 

#include "Arduino.h"
#include "microcontroladores/motorcc_arduino.h"

void init();
void setup();
void loop();

// Objetos controladores como variables globales

	Controlador_PID controlador1(A0, 0, A1, 0, 1.2, 1, 0, 0.1);
	Controlador_PID controlador2(A2, 2, A3, 1, 2, 3, 0, 0.01);

int main(void) // Se necesita una función main que llamará a setup al inicio y repetirá el 
			   // bucle loop 
{
	init();

#if defined(USBCON)
	USBDevice.attach();
#endif

	setup();

	for (;;) {
		loop();
		if (serialEventRun) serialEventRun();
	}

	return 0;
}

void init() { // Iniciación	
	
}

void setup() { // Configuración inicial

}

void loop() { // Bucle de operación

	controlador1.actualiza();
	controlador2.actualiza();
	
}