//
// Control_motorcc_hw2.cpp: Implementación del dispositivo controlador para motor ejemplo de entrada/salida real HW2 
//



#include "base.h"
#include "sistemas/controlador_motorcc.h"
#include "sistemas/constante.h"

#include "microcontroladores/discretizador_motorcc_hw2.h"

#include <iostream>

int main()
{

	
// CREACION DE WATCHDOGS ---------------------------------------------------------------------

	Watchdog<float> *watchdog_control_motorCC = new Watchdog<float>(20,5901);

// CREACION DE CONTROLADORES -----------------------------------------------------------------
	
	Control_motorCC *control_motorCC = new Control_motorCC(50,1901, watchdog_control_motorCC,1,1.5,0, true);
						// true = El controlador detiene el motor (voltaje cero) si hay alarma.
	
// CREACION DE DISPOSITIVOS GENERADORES Y FUNCIONES MATEMATICAS ------------------------------

	Constante *consigna = new Constante(1,2901,100,-1000,1000);

// CREACION DE BUSES -------------------------------------------------------------------------


// CREACION DE DISCRETIZADORES ---------------------------------------------------------------
	
	Discretizador_motorcc_HW2 *discret_mot = new Discretizador_motorcc_HW2(50,4901);			
	
// CREACION DE CONECTORES --------------------------------------------------------------------	
										   
// CREACION DE GRABADORES --------------------------------------------------------------------	
	Grabador *grabador = new Grabador(10,8901, PROCESO_CONTROLADOR, false, 500); // 500 kbytes de grabacion max
										   
// CREACION DE LOS CONECTORES DE RECOLECCION DE DATOS (para grabar)---------------------------

	Conector_rec *control_dis = new Conector_rec(6901, grabador); // Entre controlador y discretizador 
	Conector_rec *consig_control = new Conector_rec(6902, grabador); // Entre consigna y controlador
	
// CONECTAMOS TODOS LOS COMPONENTES	----------------------------------------------------------	
		
	control_motorCC -> conectar(control_dis,1); 
	discret_mot -> asociar(control_dis); // Obtiene datos en discretizador, para E/S, con este conector 
	discret_mot -> conectar(control_dis, 1); // Conectado
	
	
	consigna -> conectar(consig_control, 1); // Conectamos controlador a la consigna
	control_motorCC -> conectar(consig_control, 2);
	
// CREAMOS SONDAS PARA GRABAR DATOS A ARCHIVO EXTERNO ----------------------------------------
		
	control_dis -> crea_sonda(true, 0, FLOAT, "Vel. angular");
	control_dis -> crea_sonda(true, 0+sizeof(float), FLOAT, "Pos. angular");
	control_dis -> crea_sonda(true, 0+2*sizeof(float), FLOAT, "Intensidad");
	control_dis -> crea_sonda(true, 0+3*sizeof(float), BOOL, "Alarma");	
	control_dis -> crea_sonda(false, 0, FLOAT, "Voltaje_controlador");	

	consig_control -> crea_sonda(false, 0, FLOAT, "Consigna motor");	

// REGISTRAMOS CONTROLADORES EN WATCHDOGS ----------------------------------------------------
	
	watchdog_control_motorCC -> registrar(control_motorCC, 20, true); // Registro del controlador en el watchdog
											// Conteo de 20 (ver fmuestreo de watchdog, y cierre si se supera)

// CREAMOS EL MENU INTERACTIVO ---------------------------------------------------------------
	
	Interactivo menu;
	
// REGISTRAMOS TODOS LOS DISPOSITIVOS EN EL MENU INTERACTIVO ---------------------------------	
	
	menu.registro(control_dis, "conector control-motor");
	menu.registro(consig_control, "conector consigna-control");
	menu.registro(discret_mot, "Discretizador controlador HW2");
	menu.registro(control_motorCC, "Controlador motorcc");
	menu.registro(watchdog_control_motorCC,"Watchdog-motorcc");
	menu.registro(consigna,"Consigna de entrada");
	menu.registro(grabador, "Grabador");
	
	
// EJECUTAMOS MENU INTERACTIVO ---------------------------------------------------------------

	menu.ejecutar(true); // ejecutamos y liberamos todos los objetos llamando a sus destructores (true)	
	
	std::cout << "\nSalida del programa CONTROL\n";  // Mensaje final
		
	return 0;
	
}