// Archivo de cabecera del discretizador hardware de clase HW2. Ejemplo para un motor CC

#include "../base.h" // Base de dispositivos
#include "../sistemas/estructuras_datos.h" // Estructuras de datos empleadas, en concreto la del motor CC; esid = +-3

#define ESCALA_ADC 256 // 8 bits que tiene cada convertidor A/D PCF8591
#define ESCALA_DAC 256 // 8 bits que tiene el convertidor D/A PCF8591

/* DEFINIMOS VALOR MAXIMO Y MINIMO DE LA VELOCIDAD DEL TACÓMETRO DE ENTRADA (DE ENTERO A FLOAT) EN RADS/SEG */

#define MAX_TAC 10000.
#define MIN_TAC -10000.

/* DEFINIMOS VALOR MAXIMO Y MINIMO DEL VOLTAJE DE SALIDA AL MOTOR (DE FLOAT A ENTERO) EN VOLTIOS */

#define MAX_VOL 50.
#define MIN_VOL -50.

/* DEFINICIONES PARA LA PLACA A UTILIZAR */
//#define PCF 120 // Pin para la placa A/D y D/A PCF8591 por bus I2C

//#include <wiringPi.h>
//#include <pcf8591.h>

#define PIN_ALARMA	4 // Pin digital desde el cual se lee la alarma (GPIO). Se asigna GPIO4

class Discretizador_motorcc_HW2 : public Discretizador_HW2 {

	// Punteros de estructuras de datos esid=3 (salida/entrada del MotorCC al controlador)

	struct ENTRADA_ES_3_HW *entrada_es_3; 
	struct SALIDA_ES_3_HW *salida_es_3; 
	
	// Salida: del hardware al controlador; Entrada: del controlador al hardware	
	// Estos punteros a estructuras han de apuntar a los buffers reservados por el discretizador en asociar();

protected:
	void rutina(); // Rutina de hilo discretizador HW2 motor CC
	void hardware(); // Rutina de hardware discretizador HW2 motor CC
	int actualiza(); //actualizador y rutina del thread 

public:	
	Discretizador_motorcc_HW2(unsigned int t, int id); // Constructor
	// La rutina "asociar" la proporciona la superclase Discretizador_HW2
	~Discretizador_motorcc_HW2(); // Destructor. Necesario para finalizar conexiones con hardware
	
	int asociar(Conector *conector); // Asociación
	
};