// Planta_amort.cpp: Implementación de los dispositivos de planta del amortiguador. 


//#include "base.h"
#include "sistemas/aleatorio.h"
#include "sistemas/funciones_periodicas.h"
#include "sistemas/amortiguador.h"
#include "sistemas/constante.h"
#include "base.h"

#include <iostream>

int main()
{	

// CREACION DE CONTROLADORES -----------------------------------------------------------------

	
// CREACION DE DISPOSITIVOS DE FISICOS DE PLANTA, GENERADORES Y FUNCIONES MATEMATICAS --------

//	Constante *calzada = new Constante(1,201,0.,100,-100);

	
	Aleatorio *perturbacion_actuador = new Aleatorio(30,2201,419,577,129,899,1002,-10,10);	
	Periodica *calzada = new Periodica(100,2202,F_TRIANGULAR,300,300,-0.4,0.4);
	Amortiguador *amortiguador = new Amortiguador(500,2203,250,20,15000,150000,3150,0.,0.,0.,0.,1,9900,10000); 

// CREACION DE BUSES -------------------------------------------------------------------------
	
	Bus *bus = new Bus(3201, PROCESO_PLANTA);	

// CREACION DE DISCRETIZADORES ---------------------------------------------------------------
	
	Discretizador *discret_amo = new Discretizador(50,4201,2, bus);	

// CREACION DE WATCHDOGS ---------------------------------------------------------------------

	
	
// CREACION DE CONECTORES CONVENCIONALES -----------------------------------------------------
	
/*	Conector *cal_amo = new Conector(601); // Entre calzada (generador función periodica) y rueda del amortiguador
	Conector *amo_dis = new Conector(602); // Entre amortiguador y discretizador	
	Conector *per_amo = new Conector(603); // Entre "ruido" (perturbaciones) y actuador del amortiguador
										   // (imperfecciones del actuador) */
										   
// CREACION DE GRABADORES --------------------------------------------------------------------
	
	Grabador *grabador = new Grabador(10,8201, PROCESO_PLANTA, false, 500); // escogemos 500 kbytes máximo de capacidad

	
// CREACION DE LOS CONECTORES DE RECOLECCION DE DATOS (para grabar)---------------------------

	
											
	Conector_rec *amo_dis = new Conector_rec(7201, grabador); //Entre amortiguador y discretizador	
	Conector_rec *per_amo = new Conector_rec(7202, grabador); //Entre "ruido" (perturbaciones) y actuador del amortiguador
												   // (imperfecciones del actuador)
	Conector_rec *cal_amo = new Conector_rec(7203, grabador); 
										// Entre calzada (generador función periodica) y rueda del amortiguador
	
// CONECTAMOS TODOS LOS COMPONENTES	----------------------------------------------------------	
		
	perturbacion_actuador -> conectar(per_amo,1); // amortiguador-perturbacion
	amortiguador -> conectar(per_amo,3);
	
	calzada -> conectar(cal_amo,1); // Amortiguador-calzada
	amortiguador -> conectar(cal_amo,2);
	
	
	amortiguador -> conectar(amo_dis, 1); // Amortiguador-Discretizador		
	discret_amo -> asociar(amo_dis); 
									// Obtiene datos de E/S con este conector (aplicar en todos los discretizadores)
	
	discret_amo -> conectar((Conector *)amo_dis, 1); 
	
// CREAMOS SONDAS PARA GRABAR DATOS A ARCHIVO EXTERNO ----------------------------------------	
	
	amo_dis -> crea_sonda(false, 0, FLOAT, "Pos_chasis");
	amo_dis -> crea_sonda(false, 0+sizeof(float), FLOAT, "Pos_rueda");
	amo_dis -> crea_sonda(false, 0+sizeof(float)+sizeof(float), BOOL, "Alarma");
	amo_dis -> crea_sonda(true, 0, FLOAT, "Actuador");
	cal_amo -> crea_sonda(false, 0, FLOAT, "Calzada");
	per_amo -> crea_sonda(false, 0, FLOAT, "Perturbacion");

// CREAMOS EL MENU INTERACTIVO ---------------------------------------------------------------
	
	Interactivo menu;
	
// REGISTRAMOS TODOS LOS DISPOSITIVOS EN EL MENU INTERACTIVO
	
	menu.registro(perturbacion_actuador, "perturbacion");
	
	menu.registro(calzada, "calzada");
	menu.registro(amortiguador, "amortiguador");
	menu.registro(cal_amo, "conector calzada-amort");
	menu.registro(amo_dis, "conector amort-discret");
	menu.registro(per_amo, "conector per-amort");
	menu.registro(discret_amo, "Discretizador amortiguador");
	menu.registro(bus, "Bus");
	menu.registro(grabador, "Grabador");
	
// EJECUTAMOS MENU INTERACTIVO ---------------------------------------------------------------

	menu.ejecutar(true); // ejecutamos y liberamos todos los objetos llamando a sus destructores (true)	
	
	std::cout << "\nSalida del programa PLANTA\n";  // Mensaje final
		
	return 0;
	
}
