// Planta_MOTORCC.cpp: Implementación de los dispositivos de planta del motor de corriente continua. 


//#include "base.h"

#include "sistemas/funciones_periodicas.h"
#include "sistemas/motorcc.h"
#include "sistemas/constante.h"
#include "base.h"

#include <iostream>

int main()
{	

// CREACION DE WATCHDOGS ---------------------------------------------------------------------

// CREACION DE CONTROLADORES -----------------------------------------------------------------

	
// CREACION DE DISPOSITIVOS DE FISICOS DE PLANTA, GENERADORES Y FUNCIONES MATEMATICAS --------

//	Constante *voltaje = new Constante(1,2101,100.,100,-100);	
	Periodica *par_resistente = new Periodica(10,2102,F_CUADRADA,200,200,0,400);
	MotorCC *motor = new MotorCC(500,2103,10,0.1,0.3,220,30,1.9,0,0,0,0,0,20); 
 

// CREACION DE BUSES -------------------------------------------------------------------------
	
	Bus *bus = new Bus(3101, PROCESO_PLANTA);	

// CREACION DE DISCRETIZADORES ---------------------------------------------------------------
	
	Discretizador *discret_mot = new Discretizador(50,4101,2, bus);		
	
// CREACION DE CONECTORES CONVENCIONALES -----------------------------------------------------
	
//	Conector *mot_dis = new Conector(6101); //Entre motor y discretizador	
//	Conector *par_mot = new Conector(6102); // Entre par y motor	

										   
// CREACION DE GRABADORES --------------------------------------------------------------------
	
	Grabador *grabador = new Grabador(10,8101, PROCESO_PLANTA, false, 500); // 500 kbytes de grabacion max

	
// CREACION DE LOS CONECTORES DE RECOLECCION DE DATOS (para grabar)---------------------------	
											
	Conector_rec *mot_dis = new Conector_rec(7101, grabador); //Entre motor y discretizador	
	Conector_rec *par_mot = new Conector_rec(7102, grabador); // Entre par y motor		
	
// CONECTAMOS TODOS LOS COMPONENTES	----------------------------------------------------------	
		
//	voltaje -> conectar(vol_mot,1); // voltaje-motor
//	motor -> conectar(vol_mot,3);
	
	par_resistente -> conectar(par_mot,1); // par-motor
	motor -> conectar(par_mot,2);
	
	
	motor -> conectar(mot_dis, 1); // Motor-discretizador	
	discret_mot -> asociar(mot_dis); // El discretizador ha de capturar los datos de esid, del motor (asociar)
									// Obtiene datos de E/S con este conector (aplicar en todos los discretizadores)
	
	discret_mot -> conectar(mot_dis, 1); 
	
// CREAMOS SONDAS PARA GRABAR DATOS A ARCHIVO EXTERNO ----------------------------------------	
	
	mot_dis -> crea_sonda(false, 0, FLOAT, "Vel. angular");
	mot_dis -> crea_sonda(false, 0+sizeof(float), FLOAT, "Pos. angular");
	mot_dis -> crea_sonda(false, 0+2*sizeof(float), FLOAT, "Intensidad");
	mot_dis -> crea_sonda(false, 0+3*sizeof(float), BOOL, "Alarma");	
	
	par_mot -> crea_sonda(false, 0, FLOAT, "Par_externo");	

// CREAMOS EL MENU INTERACTIVO ---------------------------------------------------------------
	
	Interactivo menu;
	
// REGISTRAMOS TODOS LOS DISPOSITIVOS EN EL MENU INTERACTIVO
	
//	menu.registro(voltaje, "Voltaje_entrada");
	
	menu.registro(par_resistente, "Par_resistente");
	menu.registro(motor, "Motor");
//	menu.registro(vol_mot, "conector vol_mot");
	menu.registro(par_mot, "conector par_mot");
	menu.registro(mot_dis, "conector mot_dis");
	menu.registro(discret_mot, "Discretizador motor");
	menu.registro(bus, "Bus");
	menu.registro(grabador, "Grabador");
	
// EJECUTAMOS MENU INTERACTIVO ---------------------------------------------------------------

	menu.ejecutar(true); // ejecutamos y liberamos todos los objetos llamando a sus destructores (true)	
	
	std::cout << "\nSalida del programa PLANTA\n";  // Mensaje final
		
	return 0;
	
}
