// aleatorio.h 
//
// Generador de números aleatorios. Distribución uniforme en el que elegimos un valor medio y un rango de números
//
// Método de generación congruencial aditivo de cuatro semillas. 
//
// Este dispositivo de planta es de sólo salida y provee una señal de perturbación o ruido para algunos
// dispositivos de planta como podría ser el amortiguador. 

#include "../base.h" // Base de dispositivos
#include "estructuras_datos.h" // 


class Aleatorio : public Dinamico<unsigned int> { // La clase base es Dinamico. Lo trataremos como dispositivo
											      // dinámico o con memoria 
											      // (concretamente, cola de cuatro elementos enteros). 

	
// Entrada-salida del dispositivo Aleatorio
	

	
	struct salida { // Es un dispositivo de solo salida. Nunca recibe información. 
					// Sirve como estímulo o perturbación para otros dispositivos que se conecten a éste
	
		float aleat_salida; 
	
	};
	
//	std::deque<unsigned int>  secuencia; // Secuencia de números aleatorios	
	unsigned int modulo; // módulo de la generación de los números
	
	float sup; // máximo y mínimo del intervalo a generar (distribución uniforme) 
	float inf;
	float rango;	
	
	std::atomic<bool> modificado {false}; // ¿Se modificaron los valores con propiedades? A actualizar	
	
	float sup_m; // máximo y mínimo del intervalo a generar (distribución uniforme) 
	float inf_m; // del menú de edición en propiedades()
	float rango_m;	
	
	float num; // número aleatorio calculado	

protected: 
	void configura(unsigned int k1, unsigned int k2, unsigned int k3, unsigned int k4, 
												unsigned int modulo, float sup, float inf); // configura variables internas
	void rutina();
	int actualiza(); // Actualización
	
	// Entrada-salida del dispositivo de salida de números aleatorios
	
	struct ES_2 es_2_1; // Estructura de datos esid = 1 de salida, por puerto 1 
	
public:
	Aleatorio(unsigned int t, int id, unsigned int k1, unsigned int k2, unsigned int k3, unsigned int k4, 
												unsigned int modulo, float sup, float inf); // Constructor
												
	void propiedades(); // Propiedades de Aleatorio
	void propiedades_base(); // Propiedades base 
	
};

