// CARRO_MOTORIZADO.H /// CARRO DE TRANSPORTE LINEAL UNIDO A UN MOTOR POR TORNILLO SINFIN.

// Tiene dos finales de carrera en cada extremo, a una distancia de los topes, para dar margen al frenado
		
		// Entrada: Voltaje al motor  e1    ----------------> Puerto 4 
		// Salida: Posicion respecto al origen  s1
		//		   velocidad absoluta s2
		//         corriente bobina   s3
		//         fin_carrera_D      s4
		//         fin_carrera_I      s5
		// 		   Alarma             alarma
		
		// Entrada: Rozamiento del carro e1 --------------------> Puerto 5
		
		
		// Entrada: Voltaje al motor e1 --------------------> Puerto 6 
		
	
		// Nota: La masa en el carro, multiplicada por la gravedad nos da la fuerza normal en el eje de movimiento
		// Y esta resistirá el movimiento en proporción al rozamiento del puerto 5
		
// Los tres primeros puertos están ocupados por la clase base MotorCC Por eso se empieza en el 4. 


// #include "../base.h" // Base de dispositivos
#include "motorcc.h" // Motor eléctrico. Usaremos su modelo 
//#include "estructuras_datos.h"
#include <iostream>

#ifndef GRAV
#define GRAV 9.8 // Constante gravitatoria 9.8 m/s^2
#endif

#define PARAMETRIZACIONCC_CARRO1 10,0.1,0.3,220,30,1.9,0,0,0,0,0,50 // Parametros del motor CC

class Carro : public MotorCC { // clase derivada
	
protected: 
    void configura(float c, float m, float posdd, float postd, float posdi, float posti, float posini); 
															

	void rutina();
	int actualiza(); // Actualización del carro
	
	float c, m, posdd, postd, posdi, posti, posini; // Parámetros del carro 

	float o_max, o_min; // Angulo máximo y mínimo del motor (alcanzando tope) 
	
//	float pos, vel; // Posición y velocidad instantánea del carro
	
	// ////////// Entrada-salida del carro 
	
		
	struct ES_4 es_4_4; // Estructura de datos esid=3 al puerto 4 (entrada/salida del MotorCC al controlador)
	
	struct ES_N2 es_n2_5; // Estructura de datos esid=-2 al puerto 5 (coeficiente de rozamiento)
	
						  // estructura de datos esid=-2 al puerto 6 (voltaje de entrada al motor). 
						  
	// El puerto 6, de conectarse, sobreescribe la entrada del puerto 4. Hay que tenerlo en cuenta
						 // cuando conectamos el controlador y queremos regular el voltaje desde ahí. 
	
	
public:
	Carro(unsigned int t, int id, float c, float m, float posdd, float postd, float posdi, float posti, float posini); 
																// constructor del carro
	
};