// Combinacion_lineal.h

// Se suman, restas o se realiza una combinación lineal de ambas, obteniendo una resultado a la salida 

// s = salida; e1= entrada, e2= entrada ---> s = a * e1 + b * e2 con a,b números reales. 

#include "combinacion_lineal.h"
#include <iostream> // Necesario para la interacción con el usuario en propiedades();


Combinacion::Combinacion(unsigned int t, int id, float a, float b) : Conectable(t,id) {
												//constructor
												
	Combinacion::configura(a, b); // llamada al configurador	
												
}

void Combinacion::configura(float a, float b) { //configurador
												
	Combinacion::a = a;
	Combinacion::b = b;	 
	
	// Habilitar el puerto para ser conectado
	
	//AVISO: Las salidas desde el dispositivo son entradas desde el conector
	//       Una entrada se considera salida y viceversa, al crear las conexiones.
	//		 Esto es aplicable en todas las conexiones y hay que tenerlo en cuenta al crear el dispositivo
	
		Conectable::nuevo_puerto(1,-2,(BYTE *)nullptr,(BYTE *)&Combinacion::es_n2_1.entrada, // Tres puertos
							0, sizeof(Combinacion::es_n2_1.entrada));

		Conectable::nuevo_puerto(2,-2,(BYTE *)nullptr,(BYTE *)&Combinacion::es_n2_2.entrada,
							0, sizeof(Combinacion::es_n2_2.entrada));

		Conectable::nuevo_puerto(3,2,(BYTE *)&Combinacion::es_2_3.salida,(BYTE *)nullptr,
							sizeof(Combinacion::es_2_3.salida), 0);
}

int Combinacion::actualiza() { // Rutina de actualización por cada iteracción de muestreo
	
	int resultado = 0;
		
	Combinacion::es_2_3.salida.s1 = Combinacion::a * Combinacion::es_n2_1.entrada.e1 +
									Combinacion::b * Combinacion::es_n2_2.entrada.e1;
	
				// Se coloca valor apropiado en el buffer de salida
			
	resultado += Conectable::actualiza(); // Actualizar la clase base
													   
	return resultado;
	
}

void Combinacion::rutina() { // Rutina de thread 
	
	while (Dispositivo::obtiene_ejecucion()) {
		
		Combinacion::actualiza();
	}
	
}

void Combinacion::propiedades() { // Menú del dispositivo. Nos ofrece información muy básica: Los valores a y b
	
	unsigned int opcion; 
	float a, b;

	do {
		std::cout << "\n\n-------- PROPIEDADES DE LA COMBINACION LINEAL -----------------------\n\n";
	
		std::cout << "\t\ta:\t" << Combinacion::a;
		std::cout << "\n\t\tb:\t" << Combinacion::b;
		
	
		std::cout << "\n\n\t1) Modificar valor a";
		std::cout << "\n\t2) Modificar valor b";
		
		std::cout << "\n\n\t0) Salir";
		
		std::cout << "\n\n---------------------------------------------------------------------\n\n\n";
		
		std::cout << "\n\nSeleccione opción -> "; 
		std::cin >> opcion; //espera orden de teclado			 
		
		switch(opcion) {
			case 1:
				std::cout << "\n\nIntroduzca nuevo valor a -> ";
				std::cin >> a; //espera orden de teclado
				Combinacion::a = a; 				
				break;
			case 2:
				std::cout << "\n\nIntroduzca nuevo valor b -> ";
				std::cin >> b; //espera orden de teclado
				Combinacion::b = b; 		
				break;			
			default:
				break;		
		};	

	} while (opcion != 0);	
		
	return;
	
}
