// Constante.cpp
//
// Un sencillo dispositivo estático configurable en tiempo real que suministra un valor constante


#include "constante.h"
#include <iostream> // Necesario para la interacción con el usuario en propiedades();

Constante::Constante(unsigned int t, int id, float valor, float superior, float inferior) : Conectable(t,id) {
												//constructor
												
	Constante::configura(valor, superior, inferior); // llamada al configurador	
												
}

void Constante::configura(float valor, float superior, float inferior) { //configurador
												
	

	Constante::limite_superior = superior > inferior ? superior : inferior; // Si inferior > superior, invertir orden
	Constante::limite_inferior = superior > inferior ? inferior : superior;
	
	Constante::valor = valor;
	
	if(valor > Constante::limite_superior) Constante::valor = Constante::limite_superior; // El valor no puede estar
	if(valor < Constante::limite_inferior) Constante::valor = Constante::limite_inferior; // fuera de límites
			
	
	 
	
	// Habilitar el puerto para ser conectado
	
	//AVISO: Las salidas desde el dispositivo son entradas desde el conector
	//       Una entrada se considera salida y viceversa, al crear las conexiones.
	//		 Esto es aplicable en todas las conexiones y hay que tenerlo en cuenta al crear el dispositivo
	
		Conectable::nuevo_puerto(1,2,(BYTE *)&Constante::es_2_1.salida,(BYTE *)nullptr,
							sizeof(Constante::es_2_1.salida), 0);

												
}

int Constante::actualiza() { // Rutina de actualización por cada iteracción de muestreo
	
	int resultado = 0;
		
	Constante::es_2_1.salida.s1 = Constante::valor; // Se coloca valor en el buffer de salida
			
	resultado += Conectable::actualiza(); // Actualizar la clase base
													   
	return resultado;
	
}

void Constante::rutina() { // Rutina de thread 
	
	while (Dispositivo::obtiene_ejecucion()) {
		
		Constante::actualiza();
	}
	
}

void Constante::propiedades() { // Propiedades. Se puede modificar valor. Se crea un pequeño menú

	unsigned int opcion; 
	float valor;


	do {
		std::cout << "\n\n-------- PROPIEDADES DEL DISPOSITIVO NUMERO CONSTANTE ---------------\n\n";
	
		std::cout << "\t\tValor:\t\t" << Constante::valor;
		std::cout << "\n\n\t\tValor máximo:\t" << Constante::limite_superior;
		std::cout << "\n\t\tValor mínimo:\t" << Constante::limite_inferior;	
	
		std::cout << "\n\n\n\t1) Modificar valor";
		std::cout << "\n\n\t0) Salir";
		
		std::cout << "\n\n---------------------------------------------------------------------\n\n\n";
		
		std::cout << "\n\nSeleccione opción -> "; 
		std::cin >> opcion; //espera orden de teclado
		
		if (opcion == 1) {
			do {
				std::cout << "\n\nIntroduzca nuevo valor constante -> ";
				std::cin >> valor; //espera orden de teclado
				
				if (valor <= Constante::limite_superior && valor >= Constante::limite_inferior) break; 
				
				std::cout << "\n\nEl valor introducido ha de estar entre el valor máximo y mínimo";
			
			} while (valor > Constante::limite_superior || valor < Constante::limite_inferior); // Salir del bucle
			Constante::valor = valor;			// Si está dentro de los límites
		}

	} while (opcion != 0);
	
return;
}