// Control_amortiguador.h 
//
// Controlador PID del amortiguador


#include "../base.h" // Base de dispositivos
#include "estructuras_datos.h"
#include <iostream>


class Control_amortiguador : public Control_PID<float> { // Utilizaremos aritmética con números 'float'


protected: 
	void configura(); //configuracion de controlador 

	void rutina(); // Rutina del dispositivo
	int actualiza(); // Actualización
	
	
	// ////////// Entrada-salida del dispositivo del controlador del amortiguador
	
		
	struct ES_N1 es_n1_1; // Estructura de datos esid=-1 al puerto 1 (entrada/salida del controlador al amortiguador)
	
	struct ES_N2 es_n2_2; // Estructura de datos esid=-2 al puerto 2 (entrada de consigna) 
	
	struct ES_2 es_2_3; // Estructura de datos esid=2 al puerto 3 (salida a otro controlador/cascada)
	
public:
	Control_amortiguador(unsigned int t, int id, Watchdog<float> *watchdog, float p, float i, float d); 
																// constructor del controlador
//	void propiedades();
	
};