// CONTROLADOR_CARRO_MOTORIZADO.H
//
// Controlador del carro. Controlador específico. No PID. 
//  

#include "../base.h" // Base de dispositivos
#include "estructuras_datos.h"
#include <iostream>

class Control_carro : public Controlador<float> { // Utilizaremos controlador 'float' debido a la aritmética

	std::atomic<long unsigned int> contador{0}; 
				// Contador de espera (temporizador cada vez que el carro se detiene por llegar a detector
	std::atomic<bool> movimiento; // Movimiento del motor false -> a la derecha ; true -> a la izquierda.
	std::atomic<bool> parada{false}; // Parada del motor, modificable en propiedades

protected: 
	void configura(bool movimiento); //configuracion de controlador 

	void rutina(); // Rutina del dispositivo
	int actualiza(); // Actualización	
	
	// ////////// Entrada-salida del dispositivo del controlador del motor	
		
	struct ES_N4 es_n4_1; // Estructura de datos esid=-3 al puerto 1 (entrada/salida del controlador al motorCC)
	
	struct ES_N2 es_n2_2; // Estructura de datos esid=-2 al puerto 2 (entrada de consigna VOLTAJE) 
	
	struct ES_N2 es_n2_3; // Estructura de datos esid=-2 al puerto 3 (entrada de consigna DURACION PARADA en pulsos) 
	
	// No hay puerto de salida para configuración en cascada 
	
public:
	Control_carro(unsigned int t, int id, Watchdog<float> *watchdog, bool movimiento); 
																// constructor del controlador
	void propiedades(); // propiedades
	
};