// Control_motorcc.h 
//
// Controlador PID del motorCC. Es esencialmente el mismo que el amortiguador, sólo que cambiando de estructura de datos
// en un puerto. 


#include "../base.h" // Base de dispositivos
#include "estructuras_datos.h"
#include <iostream>


class Control_motorCC : public Control_PID<float> { // Utilizaremos aritmética con números 'float'
	bool apag = false; // Bit de apagado en caso de alarma

protected: 
	void configura(); //configuracion de controlador 

	void rutina(); // Rutina del dispositivo
	int actualiza(); // Actualización
	
	
	// ////////// Entrada-salida del dispositivo del controlador del motor
	
		
	struct ES_N3 es_n3_1; // Estructura de datos esid=-3 al puerto 1 (entrada/salida del controlador al motorCC)
	
	struct ES_N2 es_n2_2; // Estructura de datos esid=-2 al puerto 2 (entrada de consigna) 
	
	struct ES_2 es_2_3; // Estructura de datos esid=2 al puerto 3 (salida a otro controlador/cascada)
	
public:
	Control_motorCC(unsigned int t, int id, Watchdog<float> *watchdog, float p, float i, float d, bool apag); 
																// constructor del controlador
//	void propiedades();
	
};