// DEPOSITO.H /// Depósito de líquido, con tubería de carga y sumidero de descarga (caudal de salida).
		
		// Entrada: Caudal que entra en el depósito    ----------------> Puerto 1 
		// Salida: Altura             s1
		//		   Caudal de salida   s2		       
		// 		   Alarma             alarma
		
		// Entrada: Coeficiente de descarga            ---------------> Puerto 2
		
		
		// Entrada: Caudal que entra ---------------------------------> Puerto 3
		
	
		
		
// Observación: El puerto 3 se antepone al puerto 1 por las mismas causas que con el motor y el carro. El puerto 3
// sirve para ensayar el sistema, en planta. El puerto 1 tiene el propósito de conectarlo al controlador 


#include "../base.h" // Base de dispositivos
#include "estructuras_datos.h"
#include <iostream>

#ifndef GRAV
#define GRAV 9.8 // Constante gravitatoria 9.8 m/s^2
#endif


class Deposito : public Continuo<float> {
	
	float h_max; // Altura máxima
	float h_init; // Altura inicial	
	float ks_init;    // Coeficiente de descarga inicial (en función de una hipotética válvula de salida variable) 
	
	float as;    // Area (sección) del conducto de sumidero 
	float c1; 	 // Constante c1. c Será variable según el coef. de descarga 
	
// Nota: El modelo matemático está expuesto en la memoria del trabajo. 
	
protected: 	

	void rutina();
	int actualiza(); // Actualización del motor
	
	// ////////// Entrada-salida del motor (Está en protected porque así accederán las clases derivadas de MotorCC)
	
		
	struct ES_3 es_1_1; // Estructura de datos esid=1 al puerto 1 (entrada/salida del depósito al controlador)
	
	struct ES_N2 es_n2_2; // Estructura de datos esid=-2 al puerto 2 (coeficiente de descarga variable)
	
						  // estructura de datos esid=-2 al puerto 3 (caudal de entrada). 
						  
						 // El puerto 3, de conectarse, sobreescribe la entrada del puerto 1. Hay que tenerlo en cuenta
						 // cuando conectamos el controlador y queremos regular el caudal desde ahí. 
	
	
public:
	void configura(float as, float h_max, float h_init, float qe_init, float qs_init, float ks_init); 
																//configuracion del depósito
	
	Deposito(unsigned int t, int id, float as, float h_max, float h_init, float qe_init, float qs_init, float ks_init); 
																// constructor del depósito
	
};