// MOTORCC.H /// Motor eléctrico acoplado a una carga.
		
		// Entrada: Voltaje al motor  e1    ----------------> Puerto 1 
		// Salida: velocidad de giro  s1
		//		   posicion de giro   s2
		//         corriente bobina   s3
		// 		   Alarma             alarma
		
		// Entrada: Carga mecánica Tsf  e1   ---------------> Puerto 2
		
		
		// Entrada: Voltaje al motor e1 --------------------> Puerto 3 
		
	
		
		
// Las clases derivadas pueden hacer uso de las variables protegidas de MotorCC, Continuo y Dinamico y así
// construir variaciones del motor, aunque se recomienda que no usen la misma numeración de puertos que esta clase
// En su caso, empezaría por el puerto 4 


#include "../base.h" // Base de dispositivos
#include "estructuras_datos.h"
#include <iostream>


class MotorCC : public Continuo<float> {
	
	float lr; // Constantes para los cambios en los términos independientes
	float il; 
	
	float i_max; // Corriente máxima por la bobina (causa de alarma si se sobrepasa)

	
protected: 
	void configura(float rr, float lr, float ke, float ks, 
						float il, float b, float v_init, float i_init, 
							float w_init, float o_init, float ts_init, float i_max); 
																//configuracion del motor

	void rutina();
	int actualiza(); // Actualización del motor
	
	// ////////// Entrada-salida del motor (Está en protected porque así accederán las clases derivadas de MotorCC)
	
		
	struct ES_3 es_3_1; // Estructura de datos esid=3 al puerto 1 (entrada/salida del MotorCC al controlador)
	
	struct ES_N2 es_n2_2; // Estructura de datos esid=-2 al puerto 2 (carga mecánica aplicada al motor (par resistente))
	
						  // estructura de datos esid=-2 al puerto 3 (voltaje de entrada). 
						  
						 // El puerto 3, de conectarse, sobreescribe la entrada del puerto 1. Hay que tenerlo en cuenta
						 // cuando conectamos el controlador y queremos regular el voltaje desde ahí. 
	float ks, b; // Será utilizado por clases derivadas que desean "puentear" las ecuaciones dinamicas
				 // como la velocidad angular
	
public:
	MotorCC(unsigned int t, int id, float rr, float lr, float ke, float ks, 
						float il, float b, float v_init, float i_init, 
										float w_init, float o_init, float ts_init, float i_max); 
																// constructor del motor
	
};